/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.commons.util;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * blanco Framework̖OɊւ郆[eBeBW߂NXłB
 * 
 * @author IGA Tosiki
 */
public class BlancoNameUtil {
    /**
     * ^ꂽOt@CƂėpÓǂ𔻒f܂B
     * 
     * ^FGHhb^ꂽfalse߂܂B
     * 
     * @param checkString
     *            t@CƂĔ肷镶B
     * @return t@CƂđÓłtrueAÓłȂ false߂܂B
     */
    public static final boolean isValidFileName(final String checkString) {
        if (checkString == null) {
            throw new IllegalArgumentException(
                    "t@CƂđÓǂ肷郁\bhnull^܂BnullȊO̒l^ĂB");
        }

        if (checkString.indexOf('/') >= 0 || checkString.indexOf('\\') >= 0
                || checkString.indexOf(':') >= 0
                || checkString.indexOf(';') >= 0
                || checkString.indexOf('*') >= 0
                || checkString.indexOf('?') >= 0
                || checkString.indexOf('\"') >= 0
                || checkString.indexOf('>') >= 0
                || checkString.indexOf('<') >= 0
                || checkString.indexOf('|') >= 0) {
            // ̕܂܂Ăt@CƂĂ͕sK؂łB
            return false;
        }
        return true;
    }

    /**
     * t@CƂėpׂłȂ̈ꗗ\`Ŏ擾܂B
     * 
     * @return pׂłȂ̈ꗗ\`ł킵́B
     */
    public static final String invalidFileNameChar() {
        return "/ \\ : ; * ? \" > < |";
    }

    /**
     * t@C(fBNg͊܂܂ȂԂŗ^܂)gq܂B
     * 
     * hbg͊gqƓ܂B<br>
     *  .cvsignorê悤ȃt@C^ꂽꍇɂ́Â܂ܖ߂܂B
     * 
     * @param checkString
     *            t@C(fBNg܂܂Ȃ)
     * @return gq܂܂Ȃt@C
     */
    public static final String trimFileExtension(final String checkString) {
        if (checkString == null) {
            throw new IllegalArgumentException(
                    "t@Cgq菜\bhnull^܂BnullȊO̒l^ĂB");
        }

        // Ō̊gqTo܂B
        final int posDot = checkString.lastIndexOf(".");
        if (posDot == 0) {
            // ̃t@C̓hbgJnt@CłB
            // gq̐؂͍s킸ɁÂ܂ܕԂ܂B
            return checkString;
        }
        if (posDot > 0) {
            // gq܂B
            return checkString.substring(0, posDot);
        }

        return checkString;
    }

    /**
     * ^ꂽw肳ꂽ؂蕶ŕ܂B
     * 
     * ؂蕶 '/'łꍇ͉̋L̒ʂB<br>
     * ʏP[X1F[aaa/bbb/ccc]{ "aaa", "bbb", "ccc" }<br>
     * ʏP[X2F[aaa//ccc]{ "aaa", "", "ccc" }<br>
     * ʏP[X3: [/aaa/bbb]{ "", "aaa", "bbb" }<br>
     * ŏ̃XbV͈ƂăJEg܂B<br>
     * ʏP[X4F[/aaa/bbb/]{ "", "aaa", "bbb" }<br>
     * Ō̃XbV͖܂B<br>
     * <br>
     * EP[X1F[/]{ "" }<br>
     * EP[X2F[///]{ "", "", "" }<br>
     * EP[X3F[]0̔z<br>
     * EP[X4Fnull0̔z<br>
     * 
     * @param originalString
     *            ؂蕶ŋ؂ꂽBnull^ꍇɂ 0Stringz񂪖߂܂B
     * @return ꂽB؂蕶̂̂͊܂܂܂B
     */
    public static final String[] splitString(final String originalString,
            final char delimiter) {
        if (originalString == null) {
            // nullɊւẮAڂȂ̂ƂĈ܂B
            return new String[0];
        }

        final StringReader reader = new StringReader(originalString);
        StringWriter writer = null;
        final List<java.lang.String> result = new ArrayList<java.lang.String>();
        for (;;) {
            final int read;
            try {
                read = reader.read();
            } catch (IOException e) {
                e.printStackTrace();
                throw new IllegalArgumentException(
                        "[NStringReader̓ǂݍ݂ŗO܂BSz肵ȂP[XłB:"
                                + e.toString());
            }
            if (read < 0) {
                break;
            }
            if (writer == null) {
                writer = new StringWriter();
            }
            if ((char) read == delimiter) {
                if (writer != null) {
                    try {
                        writer.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                        throw new IllegalArgumentException(
                                "[NStringWriter̃N[YŗO܂BSz肵ȂP[XłB:"
                                        + e.toString());
                    }
                    result.add(writer.toString());
                    // [Nϐ̒gZbg܂B
                    writer = null;
                }
            } else {
                writer.write((char) read);
            }
        }
        if (writer != null) {
            try {
                writer.close();
            } catch (IOException e) {
                e.printStackTrace();
                throw new IllegalArgumentException(
                        "Sz肵ȂA肦ȂP[Xł̃G[܂B:" + e.toString());
            }
            result.add(writer.toString());
            // [Nϐ̒gZbg܂B
            writer = null;
        }
        return (String[]) result.toArray(new String[result.size()]);
    }

    /**
     * ^ꂽpXłƉ肵A/(XbV)Lŋ؂ĕ𕪊܂B
     * 
     * ʏP[X1F[aaa/bbb/ccc]{ "aaa", "bbb", "ccc" }<br>
     * ʏP[X2F[aaa//ccc]{ "aaa", "", "ccc" }<br>
     * ʏP[X3: [/aaa/bbb]{ "", "aaa", "bbb" }<br>
     * ŏ̃XbV͈ƂăJEg܂B<br>
     * ʏP[X4F[/aaa/bbb/]{ "", "aaa", "bbb" }<br>
     * Ō̃XbV͖܂B<br>
     * <br>
     * EP[X1F[/]{ "" }<br>
     * EP[X2F[///]{ "", "", "" }<br>
     * EP[X3F[]0̔z<br>
     * EP[X4Fnull0̔z<br>
     * 
     * @param originalString
     *            /(XbV)Lŋ؂ꂽBnull^ꍇɂ 0Stringz񂪖߂܂B
     * @return ꂽB/(XbV)L͊܂܂܂B
     */
    public static final String[] splitPath(final String originalString) {
        return splitString(originalString, '/');
    }

    /**
     * ^ꂽNXpbP[W܂B
     * 
     * @param argClassName
     *            tpbP[Wt̃NXB
     * @return pbP[W̃NXB
     */
    public static final String trimJavaPackage(final String argClassName) {
        if (argClassName == null) {
            throw new IllegalArgumentException(
                    "NXpbP[W菜\bhnull^܂BnullȊO̒l^ĂB");
        }

        // hbgŃtNX𕪊܂B
        final String[] work = splitString(argClassName, '.');
        for (int index = work.length - 1; index >= 0; index--) {
            if (work[index].length() > 0) {
                // ̕ĂAŌ̕ăNXƂ܂B
                return work[index];
            }
        }

        // ЂƂ̂O܂łB
        throw new IllegalArgumentException("[" + argClassName
                + "]pbP[WtJavaNXƂďł܂B");
    }

    /**
     * ^ꂽURIA閽Kɏ] JavapbP[W擾܂B
     * 
     * @param uri
     *            ͂ƂȂURIB
     * @return JavapbP[WB
     */
    public static final String uri2JavaPackage(final String uri) {
        if (uri == null) {
            throw new IllegalArgumentException(
                    "URIpbP[W擾郁\bhnull^܂BnullȊO̒l^ĂB");
        }

        final StringWriter writer = new StringWriter();
        final String[] splitedUri = splitString(uri, ':');
        boolean isFirst = true;
        if (splitedUri.length < 2) {
            throw new IllegalArgumentException(
                    "^ꂽURI["
                            + uri
                            + "]͌`słB[http://www.w3.org/XML/Schema]̂悤Ȍ`Ŏw肵ĂB");
        }
        final String[] splitDir = BlancoNameUtil
                .splitString(splitedUri[1], '/');
        for (int index = 0; index < splitDir.length; index++) {
            final String[] splitDomain = BlancoNameUtil.splitString(
                    splitDir[index], '.');
            for (int indexDomain = splitDomain.length - 1; indexDomain >= 0; indexDomain--) {
                // hC\Ǝvӏł̂ŁAtŏs܂B
                if (splitDomain[indexDomain].length() > 0) {
                    if (isFirst) {
                        isFirst = false;
                    } else {
                        writer.write(".");
                    }
                    writer.write(splitDomain[indexDomain]);
                }
            }
        }
        for (int indexUri = 2; indexUri < splitedUri.length; indexUri++) {
            final String[] splitDirAfter = BlancoNameUtil.splitString(
                    splitedUri[indexUri], '/');
            // |CgFŏ̃m[h |[gԍł낤 𖳎܂B
            for (int index = 1; index < splitDirAfter.length; index++) {
                if (isFirst) {
                    isFirst = false;
                } else {
                    writer.write(".");
                }
                writer.write(splitDirAfter[index]);
            }
        }

        try {
            writer.close();
        } catch (IOException e) {
            e.printStackTrace();
            throw new IllegalArgumentException(
                    "肦ȂO: StringWriterclose()̍ۂɗO܂B:"
                            + e.toString());
        }
        return writer.toString();
    }
}
